package applications;

import controllers.DominoButtonController;
import views.DominoFrame;
import models.ObservableDomino;

/**
 * A simple Model View Controller implementation of an application which displays the state of
 * a domino in a frame, and provides a controller frame with 2 buttons for switching or randomizing the domino
 * @author jpaulgibson
 * @version 1
 */
public class DominoMVC {
	
@SuppressWarnings("unused")
public static void main(String[] args){
	
	// Initial co-ordinates for the domino frame
	final int TOP_LEFT_HORIZONTAL = 100;
	final int TOP_LEFT_VERTICAL  = 200;
	
	/**
	 * The domino model, which must be observable
	 */
     ObservableDomino domino = new ObservableDomino(1,2);
		
 	/**
 	 * The domino view, in a separate frame 
 	 */
     DominoFrame dominoFrame = new DominoFrame(domino,TOP_LEFT_HORIZONTAL,TOP_LEFT_VERTICAL);
		
     /**
      * The controller (frame) which is initially placed just below the domino frame
      */
	DominoButtonController dominoController = new DominoButtonController(domino,
			                                                             TOP_LEFT_HORIZONTAL,
			                                                             TOP_LEFT_VERTICAL+dominoFrame.getHeight());
	}

}
