package models;

import java.util.Random;

import specifications.DominoSpecification;
import tools.InvariantBrokenException;

/**
 * Implementation of a domino ({@link DominoSpecification}) <br>
 * Tested by {@link tests.JUnit_Domino} and {@link tests.ValidationDomino}<br>
 * @author jpaulgibson
 * @version 1
 * @see applications.DominoMVC
 */
public class Domino  implements DominoSpecification {
	
	/**
	 * The value for the left side of the domino constructed by default
	 */
	public static final int DEFAULT_LEFT_VALUE =MIN;
	
	/**
	 * The value for the right side of the domino constructed by default
	 */
	public static final int DEFAULT_RIGHT_VALUE =MIN;
	
	
	/**
	 * The default constructor for the domino, sets both side values to MIN<br>
	 * Tested by {@link tests.JUnit_Domino#test_DefaultConstructor}
	 */
	public Domino (){
       //   TODO
	}
	
	/**
	 * A copy constructor - makes a new domino object which is  a copy of the given domino
	 * Tested by {@link tests.JUnit_Domino#test_CopyConstructorOK} and {@link tests.JUnit_Domino#test_CopyConstructorKO}
	 * @param domino_to_copy is the domino whose values are to be copied in the new object
	 * @throws IllegalArgumentException if the domino to copy is null or the domino to copy is not valid
	 */
	public Domino (DominoSpecification domino_to_copy) throws IllegalArgumentException{
	//   TODO
	}
	
	/**
	 * Construct a domino from the given left and right values<br>
	 * Tested by {@link tests.JUnit_Domino#test_Constructor} and
	 *           {@link tests.JUnit_Domino#test_ConstructorException}
	 * @param l for Left value
	 * @param r for Right value
	 * @throws IllegalArgumentException when l or r are out of bounds {@link DominoSpecification#MIN} .. {@link DominoSpecification#MAX}
	 * @throws InvariantBrokenException if the domino state is not valid after execution
	 */
	public Domino (int l, int r) throws IllegalArgumentException, InvariantBrokenException{
		// TODO
	}
	
	/**
	 * Construct a valid random domino.<br>
	 * Tested by {@link tests.JUnit_Domino#test_RandomConstructor} .
	 * @param rng the random number generator used to randomly set the domino values, if this is null then we construct it<br>
	 * @throws InvariantBrokenException if the domino state is not valid after execution
	 */
	public Domino(Random rng) throws InvariantBrokenException{
		// TODO
	}

	@Override
	public void randomize() throws InvariantBrokenException {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void randomize(Random rng) throws InvariantBrokenException {
		// TODO Auto-generated method stub
		
	}

	@Override
	public boolean invariant()  {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public DominoSpecification copy() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void switchSides() throws InvariantBrokenException {
		// TODO Auto-generated method stub
		
	}

	@Override
	public int getRightValue() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public int getLeftValue() {
		// TODO Auto-generated method stub
		return 0;
	}
	
	/**
	 * We simply calculate the hash as (3+l)*(3+r), for left and right values l and r. <br>
	 * This is coherent with the {@link Domino#equals} method that allows us to flip/switch the sides and maintain equality
	 */
	@Override
	public int hashCode(){
		
		return (getLeftValue()+3) *  (getRightValue()+3);
	}
}