package views;

import java.awt.Color;
import java.awt.Graphics;
import java.util.Observable;
import java.util.Observer;

import javax.swing.JPanel;

import models.ObservableDomino;


/**
 * The panel has a blue background and the the domino image is centralised in the canvas
 * @author jpaulgibson
 * @version 1
 */
public class DominoPanel extends JPanel implements Observer{

	 public static final Color BACKGROUND_COLOUR = Color.blue;
	 private static final long serialVersionUID = 1L;
	 private DominoImages dominoImages = DominoImages.instance();
	 private ObservableDomino domino;
		
	public DominoPanel (ObservableDomino domino, int width, int height){
			
			super();
			this.domino = domino;
			setSize(width, height);
			setBackground(BACKGROUND_COLOUR);
	}
		
	public void update(Graphics g){
			
		    paint(g);  

	 }
	
	@Override
	public void update(Observable arg0, Object arg1) {
		
		repaint();
	}

    public void paintComponent(Graphics g){
         
    	super.paintComponent(g);
        
        // to centralise the image in the frame
   		int topLeftX = (getWidth()-DominoImages.IMAGE_WIDTH)/2;
   		int topLeftY = (getHeight()-DominoImages.IMAGE_HEIGHT)/2;
   		
   		g.setColor(BACKGROUND_COLOUR);
   		g.drawRect(0, 0, getWidth(), getHeight());
   		g.drawImage(dominoImages.getDominoImage(domino.getLeftValue(), domino.getRightValue()), topLeftX,topLeftY, null);

       }
        
}
